module OW_ctrill

use lint1
use OW_type
use OW_parms_areal
use OW_ctrillwei
use OW_rndseed
use OW_hadam1
use wei_myfft_mod
!use OW_mseq

implicit none

integer,private					:: jgap,isp2

contains

!---------------------------------------------------------
subroutine owctrl_init(isp2_in,jgap_in)
integer						:: isp2_in,jgap_in

isp2=isp2_in
jgap=jgap_in

end subroutine
!---------------------------------------------------------
!subroutine owctrl(window,taper,source,recset,souset,vsal,vel,GGR,GGS)! ,window)
subroutine owctrl(taper,source,recset,souset,vsal,vel,GGR,GGS,rand1,rand2)

real, optional				:: rand1(:),rand2(:,:)
integer					:: iw,inode,i
real					:: vel(:,:),taper(:),vsal,start,finish,a(2)
real, allocatable				:: randa(:)
real					:: recset(:,:),souset(:,:),source(:)
complex					:: GGR(:,:),GGS(:,:)
complex,allocatable				:: wwr(:,:,:),wws(:,:,:),tfld(:)

integer, external				:: omp_get_thread_num

! source=sqrt(source)

!--------------------------------------------------------
if(encode) then
   if(encw) then
!      allocate(rand1(sou%w%n))
!      call init_random_seed(isp2,sou%w%n,rand1)
      do iw = 1,sou%w%n
!         write(3,*) isp2,iw,rand1(iw)
         call owctrlwei_init(iw,isp2)
!         if (nhorz.ne.0) then
!            call owctrlwei(taper,vsal,vel,recset,souset,GGR(iw,:),GGS(iw,:),rand1(iw),0.,window)
!         else
            call owctrlwei(taper,vsal,vel,recset,souset,GGR(iw,:),GGS(iw,:),rand1(iw))
!         end if
      end do
!      deallocate(rand1)
   else if (encz.or.gold) then
      do iw = 1,sou%w%n
!         allocate(rand2(sog%z%n))
!         call init_random_seed(isp2,sog%z%n,rand2)!,iw)
         call owctrlwei_init(iw,isp2)
!         if (nhorz.ne.0) then
!            call owctrlwei(taper,vsal,vel,recset,souset,GGR(iw,:),GGS(iw,:),0.,rand2,window)
!         else
            call owctrlwei(taper,vsal,vel,recset,souset,GGR(iw,:),GGS(iw,:),0.,rand2(:,iw))
!         end if
!         deallocate(rand2)
      end do
   else if (enclin) then
      do iw = 1,sou%w%n
         call owctrlwei_init(iw,isp2)
         call owctrlwei(taper,vsal,vel,recset,souset,GGR(iw,:),GGS(iw,:))
      end do
!   else if(mseq) then
!!! BEST RESULTS IN ZO SECTION eps=?? !!! 
!       allocate(randa(sog%z%n));randa=0.
!       do iw=1,sou%w%n
!          call init_random_seed((isp2-1)*sou%w%n+iw,2,a) ! somente c/ iw ha forte xtalk no SODCIG
!          randa=a(1)
!          call owctrlwei_init(iw,isp2)
!          call owctrlwei(taper,vsal,vel,recset,souset,GGR(iw,:),GGS(iw,:),0.,randa)
!       end do
!       deallocate(randa)
!!!
! Encoding in depth
!       allocate(rand2(sog%z%n));rand2=0.
!       allocate(tfld(sog%z%n));tfld=0.
!       call owmseq(3,5,rand2,2*(sog%z%n),jgap)
!       tfld=cmplx(rand2,0)
!       call FFT1DT(tfld, 1)
!       rand2=atan(imag(tfld)*real(tfld)/(real(tfld)*real(tfld)+tiny(1.)))
!       deallocate(tfld)   
!       do iw=1,sou%w%n
!!          call init_random_seed((isp2-1)*sou%w%n+iw,2,a) ! somente c/ iw ha forte xtalk no SODCIG
!!          rand2=eps*rand2+a(1)
!!          rand2=a(1)
!!          write(2,*) isp2,iw
!!          write(2,*) "=============="
!!          write(2,*) rand2
!          call owctrlwei_init(iw,isp2)
!          call owctrlwei(taper,vsal,vel,recset,souset,GGR(iw,:),GGS(iw,:),0.,rand2)
!       end do
   end if
else if (not(encode)) then
!   if (zeropi) then
!      allocate(rand1(sou%w%n))
!      do iw = 1,sou%w%n
!         if (mod(iw,2).eq.1) then
!            rand1=0.
!         else
!            do 
!         call owctrlwei_init(iw,isp2)
!         call owctrlwei(taper,vsal,vel,recset,souset,GGR(iw,:),GGS(iw,:),0.,(/0.,0./),wwr(iw,:,:),wws(iw,:,:))
!      end do
!   else
      do iw = 1,sou%w%n
         call owctrlwei_init(iw,isp2)
         call owctrlwei(taper,vsal,vel,recset,souset,GGR(iw,:),GGS(iw,:))
      end do
!   end if
end if

if (exist_file("wwr")) then
   call srite("wwr",wwr,8*sou%w%n*nx*sog%z%n)
   call srite("wws",wws,8*sou%w%n*nx*sog%z%n)
   deallocate(wwr,wws)
end if
   
end subroutine owctrl

!-------------------------------------------------------------------------------------------------

subroutine owctrlHD(taper,source,recset,souset,vsal,vel,GGR,GGS,CHD)

!complex					:: CHD(:,:)
real					:: CHD(:,:)
real,allocatable				:: HD1(:),HD2(:)
!complex,allocatable				:: HD1(:),HD2(:)
integer					:: iw,inode,i
real					:: vel(:,:),taper(:),vsal,start,finish
real, allocatable				:: rand1(:),rand2(:)
real					:: recset(:,:),souset(:,:),source(:)
complex					:: GGR(:,:,:),GGS(:,:,:)

integer, external				:: omp_get_thread_num

source=sqrt(source)

allocate(HD1(sog%z%n),HD2(sog%z%n),rand2(sog%z%n))
do iw = 1,sou%w%n
   HD1=CHD(iw,:)
   HD2=CHD(iw+sou%w%n,:)
!   HD1=atan(imag(HD(iw,:))*real(HD(iw,:))/(real(HD(iw,:))*real(HD(iw,:))+tiny(1.)))
!   HD2=atan(imag(HD(iw+sou%w%n,:))*real(HD(iw+sou%w%n,:))/(real(HD(iw+sou%w%n,:))*real(HD(iw+sou%w%n,:))+tiny(1.)))
!   HD1=HD1/maxval(HD1)
!   HD2=HD2/maxval(HD2)
!   HD1=cmplx(1,0)
!   HD2=cmplx(1,0)
   call owctrlwei_init(iw,isp2)
   call owctrlweiHD(taper,vsal,vel,recset,souset,GGR(iw,:,:),GGS(iw,:,:),HD1,HD2)
end do
deallocate(HD1,HD2)

end subroutine

end module
