module OW_wei_areal1

use sep
use OWvelo_areal
use OW_type
use OW_image_areal
use OW_fftw_areal
use OW_parms_areal

integer,private					:: ni,iwa,nwb,node,inode
real,private					:: wb

contains

!---------------------------------------------------------
subroutine owwei_init(ni_in,iwa_in,wb_in,nwb_in,node_in,inode_in)

integer						:: ni_in,iwa_in,nwb_in,node_in,inode_in
real						:: wb_in

ni=ni_in
iwa=iwa_in
wb=wb_in
nwb=nwb_in
node=node_in
inode=inode_in

end subroutine
!---------------------------------------------------------
subroutine owwei(taper,recv,source,vsal,vel,GG,rwr)

optional					:: rwr
integer						:: iz,ikx,iref,ixw
real						:: sqa,f,g
real						:: minv, maxv
real						:: taper(:),vel(:,:),vsal
real, allocatable				:: vref(:),sqa0(:)
complex, allocatable				:: ws(:),wr(:),gs0(:),gr0(:)
complex, allocatable				:: gs(:,:),gr(:,:)!,tfld(:)
complex						:: recv(:,:),source(:,:,:),GG(:,:,:),rwr(:,:)

if (allocated(wr)) deallocate(wr);allocate(wr(img%xm%n));		wr=0
if (allocated(ws)) deallocate(ws);allocate(ws(img%xm%n));		ws=0
if (allocated(gs)) deallocate(gs);allocate(gs(img%xm%n,nref));		gs=0
if (allocated(gr)) deallocate(gr);allocate(gr(img%xm%n,nref));		gr=0
if (allocated(gs0)) deallocate(gs0);allocate(gs0(img%xm%n));		gs0=0
if (allocated(gr0)) deallocate(gr0);allocate(gr0(img%xm%n));		gr0=0
if (allocated(sqa0)) deallocate(sqa0);allocate(sqa0(img%xm%n));		sqa0=0
if (allocated(vref)) deallocate(vref);allocate(vref(nref));		vref=0
!if (allocated(tfld)) deallocate(tfld);allocate(tfld(img%xm%n));		tfld=0

!!--------------------------------------------------
!! Setting FFTW plans
!!
call owfftw_init(inode,node,img%xm%n)
call owfftw_set()

ws(:)=source(:,iwa,1)
wr=recv(:,iwa) 

!        depth:do iz=nwb+1,img%z%n
        depth:do iz=1,img%z%n

!--------------------------------------------------
! Compute vref
!
            call owvref(nref,vsal,vel(iz,:),vref,minv,maxv)

!!!!!!!
            call owfftw_exeF(ws)
            call owfftw_exeF(wr)

           vxz:if (minv .eq. maxv) then
                gs0=ws;  gr0=wr;

!      Operations in the wavenumber domain
!      phase shift

                wavenumber1:do ikx = 1,kxm%n

                   sqa = rec%w%all(iwa)**2 / minv**2 - kxm%all(ikx)**2

                   evanescent1:if (sqa > 0) then
                       gs0(ikx)=gs0(ikx)*exp(cmplx(0,v%z%d*sqrt(sqa)))
                       gr0(ikx)=gr0(ikx)*exp(cmplx(0,-v%z%d*sqrt(sqa)))
                   else
                       gs0(ikx)=gs0(ikx)*exp(-sqrt(-sqa)*v%z%d)
                       gr0(ikx)=gr0(ikx)*exp(-sqrt(-sqa)*v%z%d)
                   end if evanescent1
                end do wavenumber1

                call owfftw_exeI(gs0);ws=gs0
                call owfftw_exeI(gr0);wr=gr0
 
           else
                velref: do iref=1,nref                 
                    gs(:,iref)=ws;  gr(:,iref)=wr; 
                    wavenumber2: do ikx = 1,kxm%n
!      phase shift
                        sqa = rec%w%all(iwa)**2 / vref(iref)**2 - kxm%all(ikx)**2;
                        evanescent2: if (sqa > 0) then
                            gs(ikx,iref)=gs(ikx,iref)*exp(cmplx(0,v%z%d*sqrt(sqa)));
                            gr(ikx,iref)=gr(ikx,iref)*exp(cmplx(0,-v%z%d*sqrt(sqa)));
                        else
                            gs(ikx,iref)=gs(ikx,iref)*exp(-sqrt(-sqa)*v%z%d)
                            gr(ikx,iref)=gr(ikx,iref)*exp(-sqrt(-sqa)*v%z%d)
                        end if evanescent2
                    end do wavenumber2

! Operations in x            

                      call owfftw_exeI(gs(:,iref))
                      call owfftw_exeI(gr(:,iref))

 !      split step
                      gs(:,iref) = gs(:,iref) * exp(cmplx(0,v%z%d*rec%w%all(iwa))*(1./vel(iz,:)-1./vref(iref)));
                      gr(:,iref) = gr(:,iref) * exp(cmplx(0,-v%z%d*rec%w%all(iwa))*(1./vel(iz,:)-1./vref(iref)));
                end do velref

                do iref=1,nref-1
                interpwvfld: where (vel(iz,:) >= vref(iref) .and. vel(iz,:) < vref(iref+1))
                     ws=gs(:,iref)
                     wr=gr(:,iref)
                     end where interpwvfld
                end do
                where (vel(iz,:) >= vref(nref))
                      ws=gs(:,nref)
                      wr=gr(:,nref)
                end where 

!               do ikx=1,kxm%n
!                    do iref=1,nref-1
!                        if (vref(iref) .ne. vref(iref+1)) then
!                            if (vel(iz,ikx) >= vref(iref) .and. vel(iz,ikx) < vref(iref+1)) then
!                                f=(vel(iz,ikx) - vref(iref))/vel(iz,ikx)
!                                g=1-f
!                                ws(ikx)=g*gs(ikx,iref)+f*gs(ikx,iref+1)
!                                wr(ikx)=g*gr(ikx,iref)+f*gr(ikx,iref+1)
!                            end if
!                            if (vel(iz,ikx) >= vsal) then ! ref(nref)) then
!                                ws(ikx)=gs(ikx,nref)
!                                wr(ikx)=gr(ikx,nref)
!                            end if
!                        else
!                            ws(ikx)=gs(ikx,iref)
!                            wr(ikx)=gr(ikx,iref)
!                        end if                            
!                    end do
!                end do
           end if vxz

           ws=ws*taper
           wr=wr*taper

           call owimage(ws,wr,GG(iz,:,:))
           if(exist_file("wr")) then
               rwr(iz,:)=ws
           end if
        end do depth

call owfftw_clean()

end subroutine

end module
