module OW_wei_areal

use sep
use OWvelo_areal
use OW_type
use OW_image_areal
use OW_fftw_areal
use OW_parms_areal

integer,private					:: ni,iwa,nwb,node,inode
real,private					:: wb

contains

!---------------------------------------------------------
subroutine owwei_init(ni_in,iwa_in,wb_in,nwb_in,node_in,inode_in)

integer						:: ni_in,iwa_in,nwb_in,node_in,inode_in
real						:: wb_in

ni=ni_in
iwa=iwa_in
wb=wb_in
nwb=nwb_in
node=node_in
inode=inode_in

end subroutine
!---------------------------------------------------------
subroutine owwei(taper,recv,source,vsal,vel,GG,rwr)

optional					:: rwr
integer						:: iz,ikx,iref,ixw,er
real						:: sqa,f,g
real						:: minv, maxv
real						:: taper(:),vel(:,:),vsal
real, allocatable				:: vref(:),sqa0(:)
complex, allocatable				:: ws(:),wr(:),gs0(:),gr0(:)
complex, allocatable				:: gs(:,:),gr(:,:),tfld(:)
complex						:: recv(:,:),source(:,:,:),GG(:,:,:),rwr(:,:)


er=0
if (allocated(wr)) deallocate(wr);allocate(wr(img%xm%n),stat=er);		wr=0
if(er/=0) call seperr('cant allocate wr (OW_wei_areal_mod.F90)')
if (allocated(ws)) deallocate(ws);allocate(ws(img%xm%n),stat=er);		ws=0
if(er/=0) call seperr('cant allocate ws (OW_wei_areal_mod.F90)')
if (allocated(gs)) deallocate(gs);allocate(gs(img%xm%n,nref),stat=er);		gs=0
if(er/=0) call seperr('cant allocate gs (OW_wei_areal_mod.F90)')
if (allocated(gr)) deallocate(gr);allocate(gr(img%xm%n,nref),stat=er);		gr=0
if(er/=0) call seperr('cant allocate gr (OW_wei_areal_mod.F90)')
if (allocated(gs0)) deallocate(gs0);allocate(gs0(img%xm%n),stat=er);		gs0=0
if(er/=0) call seperr('cant allocate gs0 (OW_wei_areal_mod.F90)')
if (allocated(gr0)) deallocate(gr0);allocate(gr0(img%xm%n),stat=er);		gr0=0
if(er/=0) call seperr('cant allocate gr0 (OW_wei_areal_mod.F90)')
if (allocated(sqa0)) deallocate(sqa0);allocate(sqa0(img%xm%n),stat=er);		sqa0=0
if(er/=0) call seperr('cant allocate sqa0 (OW_wei_areal_mod.F90)')
if (allocated(vref)) deallocate(vref);allocate(vref(nref),stat=er);		vref=0
if(er/=0) call seperr('cant allocate vref (OW_wei_areal_mod.F90)')
if (allocated(tfld)) deallocate(tfld);allocate(tfld(img%xm%n),stat=er);		tfld=0
if(er/=0) call seperr('cant allocate tfld (OW_wei_areal_mod.F90)')

!!--------------------------------------------------
!! Setting FFTW plans
!!

call owfftw(tfld)
write(0,*) "WEI01"

!write(0,*) "in",planF,planI

ws(:)=source(:,iwa,1) ! to be modified to handle generalized sources
wr=recv(:,iwa) 

!        depth:do iz=nwb+1,img%z%n
        depth:do iz=1,img%z%n

!--------------------------------------------------
! Compute vref
!
            call owvref(nref,vsal,vel(iz,:),vref,minv,maxv)
write(0,*) "WEI02"

!!!!!!!
            tfld=ws; call sfftw_execute(planF); ws=tfld/sqrt(1.*kxm%n)
            tfld=wr; call sfftw_execute(planF); wr=tfld/sqrt(1.*kxm%n)

           vxz:if (minv .eq. maxv) then
                gs0=ws;  gr0=wr;

!      Operations in the wavenumber domain
!      phase shift

                wavenumber1:do ikx = 1,kxm%n

                   sqa = rec%w%all(iwa)**2 / minv**2 - kxm%all(ikx)**2

                   evanescent1:if (sqa > 0) then
                       gs0(ikx)=gs0(ikx)*exp(cmplx(0,v%z%d*sqrt(sqa)))
                       gr0(ikx)=gr0(ikx)*exp(cmplx(0,-v%z%d*sqrt(sqa)))
                   else
                       gs0(ikx)=gs0(ikx)*exp(-sqrt(-sqa)*v%z%d)
                       gr0(ikx)=gr0(ikx)*exp(-sqrt(-sqa)*v%z%d)
                   end if evanescent1
                end do wavenumber1
                tfld=gs0; call sfftw_execute(planI); ws=tfld/sqrt(1.*kxm%n)
                tfld=gr0; call sfftw_execute(planI); wr=tfld/sqrt(1.*kxm%n)
 
           else
                velref: do iref=1,nref                 
                    gs(:,iref)=ws;  gr(:,iref)=wr; 
                    wavenumber2: do ikx = 1,kxm%n
!      phase shift
                        sqa = rec%w%all(iwa)**2 / vref(iref)**2 - kxm%all(ikx)**2;
                        evanescent2: if (sqa > 0) then
                            gs(ikx,iref)=gs(ikx,iref)*exp(cmplx(0,v%z%d*sqrt(sqa)));
                            gr(ikx,iref)=gr(ikx,iref)*exp(cmplx(0,-v%z%d*sqrt(sqa)));
                        else
                            gs(ikx,iref)=gs(ikx,iref)*exp(-sqrt(-sqa)*v%z%d)
                            gr(ikx,iref)=gr(ikx,iref)*exp(-sqrt(-sqa)*v%z%d)
                        end if evanescent2
                    end do wavenumber2

! Operations in x            

                      tfld=gs(:,iref); call sfftw_execute(planI); gs(:,iref)=tfld/sqrt(1.*kxm%n)
                      tfld=gr(:,iref); call sfftw_execute(planI); gr(:,iref)=tfld/sqrt(1.*kxm%n)

 !      split step
                      gs(:,iref) = gs(:,iref) * exp(cmplx(0,v%z%d*rec%w%all(iwa))*(1./vel(iz,:)-1./vref(iref)));
                      gr(:,iref) = gr(:,iref) * exp(cmplx(0,-v%z%d*rec%w%all(iwa))*(1./vel(iz,:)-1./vref(iref)));
                end do velref

                do iref=1,nref-1
                interpwvfld: where (vel(iz,:) >= vref(iref) .and. vel(iz,:) < vref(iref+1))
                     ws=gs(:,iref)
                     wr=gr(:,iref)
                     end where interpwvfld
                end do
                where (vel(iz,:) >= vref(nref))
                      ws=gs(:,nref)
                      wr=gr(:,nref)
                end where 

!               do ikx=1,kxm%n
!                    do iref=1,nref-1
!                        if (vref(iref) .ne. vref(iref+1)) then
!                            if (vel(iz,ikx) >= vref(iref) .and. vel(iz,ikx) < vref(iref+1)) then
!                                f=(vel(iz,ikx) - vref(iref))/vel(iz,ikx)
!                                g=1-f
!                                ws(ikx)=g*gs(ikx,iref)+f*gs(ikx,iref+1)
!                                wr(ikx)=g*gr(ikx,iref)+f*gr(ikx,iref+1)
!                            end if
!                            if (vel(iz,ikx) >= vsal) then ! ref(nref)) then
!                                ws(ikx)=gs(ikx,nref)
!                                wr(ikx)=gr(ikx,nref)
!                            end if
!                        else
!                            ws(ikx)=gs(ikx,iref)
!                            wr(ikx)=gr(ikx,iref)
!                        end if                            
!                    end do
!                end do
           end if vxz

           ws=ws*taper
           wr=wr*taper
write(0,*) "WEI03"

           call owimage(ws,wr,GG(iz,:,:))
write(0,*) "WEI04"
           if(exist_file("wr")) then
               rwr(iz,:)=ws
           end if
        end do depth

end subroutine

end module
